#include "rectangle.h"


//------------------------------------------------------------------
rectangle::rectangle(){
	
}

void rectangle::init() {
	catchUpSpeed = 0.2f;
	
	color.r = 255;
	color.g = 0;
	color.b = 0;
	
	pos.set(0,0);
	prevPos.set(0,0);
}

//------------------------------------------------------------------
void rectangle::draw(float rate) {
	ofFill();
	ofSetRectMode(OF_RECTMODE_CENTER); // center around the position
    ofSetColor(color.r,color.g,color.b,127);
	
	ofPushMatrix();
	ofTranslate(pos.x, pos.y, 0);
	ofRotateZ(angle * RAD_TO_DEG);
		ofSetLineWidth(4.0f);
		ofLine(0, -50, 0, 50);
		ofCircle(0, 0, ofMap(sin(ofGetFrameNum()*rate), -1, 1, 15, 20));
	ofPopMatrix();
}

//------------------------------------------------------------------
void rectangle::xenoToPoint(float catchX, float catchY){
	pos.x = catchUpSpeed * catchX + (1-catchUpSpeed) * pos.x; 
	pos.y = catchUpSpeed * catchY + (1-catchUpSpeed) * pos.y;
	
	float dx = pos.x - prevPos.x;
	float dy = pos.y - prevPos.y;
	
	angle = atan2(dy, dx);
	
	prevPos.x = pos.x;
	prevPos.y = pos.y;
}
